*==============================================================================
* Program:			AppMgr
* Purpose:			Startup program for Application Manager
* Author:			Doug Hennig
* Copyright:		(c) 2000 Stonefield Systems Group Inc.
* Last revision:	01/31/2000
*==============================================================================

lparameters tcAction, ;
	tcPopup
local lcCurrTalk, ;
	lcAction

* Save the current TALK setting and set it off.

if set('TALK') = 'ON'
	set talk off
	lcCurrTalk = 'ON'
else
	lcCurrTalk = 'OFF'
endif set('TALK') = 'ON'

* Handle the action parameter: if it isn't passed, we'll assume "INSTALL".

lcAction = iif(vartype(tcAction) <> 'C' or empty(tcAction), 'INSTALL', ;
	upper(tcAction))
do case

* If this is an "install" call, do the installation.

	case lcAction = 'INSTALL'
		do InstallAppMgr with tcPopup

* Run the application manager.

	case lcAction = 'RUN'
		do RunAppMgr
endcase

* Cleanup and return.

if lcCurrTalk = 'ON'
	set talk on
endif lcCurrTalk = 'ON'
return
		
*==============================================================================
* Procedure:		RunAppMgr
* Purpose:			Bring up the Application Manager
* Author:			Doug Hennig
* Copyright:		(c) 2000 Stonefield Systems Group Inc.
* Last revision:	01/12/2000
* Parameters:		none
* Environment in:	none
* Environment out:	the AppMgr form is run
*==============================================================================

procedure RunAppMgr
do form AppMgr
return
		
*==============================================================================
* Procedure:		InstallAppMgr
* Purpose:			Install the Application Manager in the system menu bar
* Author:			Doug Hennig
* Copyright:		(c) 2000 Stonefield Systems Group Inc.
* Last revision:	01/12/2000
* Parameters:		tcPopup - the popup to install into
* Environment in:	none
* Environment out:	the Application Manager is installed in the system menu bar
*==============================================================================

procedure InstallAppMgr
lparameters tcPopup
local lcDirectory, ;
	lnBar, ;
	lcBar, ;
	llPopup, ;
	lcPad, ;
	lnI
#define ccMENU_BAR_PROMPT   'Appl\<ication Manager'
#define ccMENU_PAD          '_MSM_TOOLS'

* Get the directory we're running in.

lcDirectory = substr(sys(16), at(' ', sys(16), 2) + 1)
lcDirectory = addbs(justpath(lcDirectory))

* Install ourselves in the appropriate menu if necessary, then return.

lnBar   = 0
lcBar   = strtran(ccMENU_BAR_PROMPT, '\<')
llPopup = vartype(tcPopup) = 'C' and not empty(tcPopup)
lcPad   = iif(llPopup, tcPopup, ccMENU_PAD)
for lnI = cntbar(lcPad) to 1 step -1
	if prmbar(lcPad, getbar(lcPad, lnI)) = lcBar
		lnBar = lnI
		exit
	endif prmbar(lcPad ...
next lnI
if lnBar = 0
	lnBar = cntbar(lcPad) + 1
	define bar lnBar     of &lcPad after _mlast prompt '\-'
	define bar lnBar + 1 of &lcPad after _mlast prompt ccMENU_BAR_PROMPT
else
	lnBar = lnBar - 1
endif lnBar = 0
on selection bar lnBar + 1 of &lcPad ;
	do locfile('&lcDirectory.APPMGR.APP', 'APP', 'Locate APPMGR.APP') ;
	with 'Run'
if not llPopup
	set sysmenu save
endif not llPopup
return
